﻿using System;
using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using SimpleJSON;
using System.Linq;

namespace Coll69 {
	public class LinkToCam : MVRScript {

		private JSONStorableFloat X;
		private JSONStorableFloat Y;
		private JSONStorableFloat Z;
		private JSONStorableFloat Xa;
		private JSONStorableFloat Ya;
		private JSONStorableFloat Za;
		
		private UIDynamicSlider sX;
		private UIDynamicSlider sY;
		private UIDynamicSlider sZ;
		private UIDynamicSlider sXa;
		private UIDynamicSlider sYa;
		private UIDynamicSlider sZa;

        private UIDynamicToggle ptoggle;
		private UIDynamicToggle ltoggle;
        private UIDynamicToggle rev_Toggle;
        private UIDynamicToggle x_Abs_Toggle;
        private UIDynamicToggle y_Abs_Toggle;
        private UIDynamicToggle z_Abs_Toggle;
        private UIDynamicToggle xa_Abs_Toggle;
        private UIDynamicToggle ya_Abs_Toggle;
        private UIDynamicToggle za_Abs_Toggle;

		private JSONStorableBool playingBool;	
		private JSONStorableBool linkBool;
		private JSONStorableBool rev_Bool;
		private JSONStorableBool x_Abs_Bool;
		private JSONStorableBool y_Abs_Bool;
		private JSONStorableBool z_Abs_Bool;
		private JSONStorableBool xa_Abs_Bool;
		private JSONStorableBool ya_Abs_Bool;
		private JSONStorableBool za_Abs_Bool;

		private JSONStorableStringChooser Target;
		private UIDynamicPopup udp;
		private Vector3 pos;
		private Quaternion rot2;
		private Quaternion rot3;
		private Quaternion rev;

		private bool linkBoolval;
		private string currentTarget;
        Rigidbody linkToAtom;

		public override void Init() {
			try {

			    JSONStorableString storable1 = new JSONStorableString("Info",
			     "LinkToCam is a modified version of\nHeadLightLink by Extraltodeus / ky1001\nwith added absolute value positions");
            	UIDynamic textfield1 = this.CreateTextField(storable1, true);
            	textfield1.height = 130.0f;

				X = new JSONStorableFloat("Position X adjustment", 0f, -10.0f, 10.0f, true);
				X.storeType = JSONStorableParam.StoreType.Full;
				sX = CreateSlider(X);
				RegisterFloat(X);
				sX.slider.onValueChanged.AddListener(delegate { linkBoolval = false; ChangeLink(); });

				Y = new JSONStorableFloat("Position Y adjustment", 0f, -10.0f, 10.0f, true);
				Y.storeType = JSONStorableParam.StoreType.Full;
				sY = CreateSlider(Y);
				RegisterFloat(Y);
				sY.slider.onValueChanged.AddListener(delegate { linkBoolval = false; ChangeLink(); });

				Z = new JSONStorableFloat("Position Z adjustment", 0f, -5.0f, 20.0f, true);
				Z.storeType = JSONStorableParam.StoreType.Full;
				sZ = CreateSlider(Z);
				RegisterFloat(Z);
				sZ.slider.onValueChanged.AddListener(delegate { linkBoolval = false; ChangeLink(); });

				Xa = new JSONStorableFloat("Rotation X adjustment", 0f, -2.0f, 2.0f, true);
				Xa.storeType = JSONStorableParam.StoreType.Full;
				sXa = CreateSlider(Xa);
				RegisterFloat(Xa);
				sXa.slider.onValueChanged.AddListener(delegate { linkBoolval = false; ChangeLink(); });

				Ya = new JSONStorableFloat("Rotation Y adjustment", 0f, -2.0f, 2.0f, true);
				Ya.storeType = JSONStorableParam.StoreType.Full;
				sYa = CreateSlider(Ya);
				RegisterFloat(Ya);
				sYa.slider.onValueChanged.AddListener(delegate { linkBoolval = false; ChangeLink(); });

				Za = new JSONStorableFloat("Rotation Z adjustment", 0f, -2.0f, 2.0f, true);
				Za.storeType = JSONStorableParam.StoreType.Full;
				sZa = CreateSlider(Za);
				RegisterFloat(Za);
				sZa.slider.onValueChanged.AddListener(delegate { linkBoolval = false; ChangeLink(); });

				playingBool = new JSONStorableBool("Play", true);
				playingBool.storeType = JSONStorableParam.StoreType.Full;
				RegisterBool(playingBool);
				ptoggle = CreateToggle((playingBool), true);

				List<string> targetChoices = new List<string>();
				targetChoices.Add("CenterEye");
				targetChoices.Add("LeftHand");
				targetChoices.Add("RightHand");

				Target = new JSONStorableStringChooser("Target", targetChoices, "CenterEye", "Choose Target");
				Target.storeType = JSONStorableParam.StoreType.Full;
				RegisterStringChooser(Target);
				udp = CreatePopup(Target, true);
				
				linkBool = new JSONStorableBool("Parent Link", false);
				linkBool.storeType = JSONStorableParam.StoreType.Full;
				RegisterBool(linkBool);
				ltoggle = CreateToggle(linkBool, true);
				ltoggle.toggle.onValueChanged.AddListener(delegate { ChangeLink(); });

                var spacer1 = CreateSpacer(true);
                spacer1.height = 25f;

                rev_Bool = new JSONStorableBool("Reverse", false);
                RegisterBool(rev_Bool);
                rev_Toggle = CreateToggle(rev_Bool, true);
				rev_Toggle.toggle.onValueChanged.AddListener(delegate { linkBoolval = false; ChangeLink(); });

                var spacer2 = CreateSpacer(true);
                spacer2.height = 25f;

			    JSONStorableString storable2 = new JSONStorableString("Info",
			     "Absolute position values only apply\nin non parent link mode");
            	UIDynamic textfield2 = this.CreateTextField(storable2, true);
            	textfield2.height = 50.0f;

                x_Abs_Bool = new JSONStorableBool("X as absolute position", false);
                RegisterBool(x_Abs_Bool);
                x_Abs_Toggle = CreateToggle(x_Abs_Bool, true);
				x_Abs_Toggle.toggle.onValueChanged.AddListener(delegate { linkBoolval = false; ChangeLink(); });

                y_Abs_Bool = new JSONStorableBool("Y as absolute position", false);
                RegisterBool(y_Abs_Bool);
                y_Abs_Toggle = CreateToggle(y_Abs_Bool, true);
				y_Abs_Toggle.toggle.onValueChanged.AddListener(delegate { linkBoolval = false; ChangeLink(); });

                z_Abs_Bool = new JSONStorableBool("Z as absolute position", false);
                RegisterBool(z_Abs_Bool);
                z_Abs_Toggle = CreateToggle(z_Abs_Bool, true);
				z_Abs_Toggle.toggle.onValueChanged.AddListener(delegate { linkBoolval = false; ChangeLink(); });

                xa_Abs_Bool = new JSONStorableBool("X angle absolute", false);
                RegisterBool(xa_Abs_Bool);
                xa_Abs_Toggle = CreateToggle(xa_Abs_Bool, true);
				xa_Abs_Toggle.toggle.onValueChanged.AddListener(delegate { linkBoolval = false; ChangeLink(); });

                ya_Abs_Bool = new JSONStorableBool("Y angle absolute", false);
                RegisterBool(ya_Abs_Bool);
                ya_Abs_Toggle = CreateToggle(ya_Abs_Bool, true);
				ya_Abs_Toggle.toggle.onValueChanged.AddListener(delegate { linkBoolval = false; ChangeLink(); });

                za_Abs_Bool = new JSONStorableBool("Z angle absolute", false);
                RegisterBool(za_Abs_Bool);
                za_Abs_Toggle = CreateToggle(za_Abs_Bool, true);
				za_Abs_Toggle.toggle.onValueChanged.AddListener(delegate { linkBoolval = false; ChangeLink(); });



			} catch (Exception e) {
                SuperController.LogError($"{nameof(LinkToCam)}.{nameof(Init)}: {e}");
			}
		}

		void Start() {
			linkBoolval = false;
			ChangeLink();
		}

		void FixedUpdate() {
			try {
				if (ptoggle.toggle.isOn) {
					if (Target.val == "CenterEye") {
						pos = SuperController.singleton.lookCamera.transform.position;
                        pos[0] = X.val;
                        pos[1] = Y.val;
                        pos[2] = Z.val;
                        pos = SuperController.singleton.lookCamera.transform.TransformPoint(pos);
						rot2 = SuperController.singleton.lookCamera.transform.rotation;
					} else if (Target.val == "LeftHand") {
                        pos = SuperController.singleton.leftHand.transform.position;
                        pos[0] = X.val;
                        pos[1] = Y.val;
                        pos[2] = Z.val;
                        pos = SuperController.singleton.leftHand.transform.TransformPoint(pos);
						rot2 = SuperController.singleton.leftHand.transform.rotation;
					} else if (Target.val == "RightHand") {
						pos = SuperController.singleton.rightHand.transform.position;
						pos[0] = X.val;
						pos[1] = Y.val;
						pos[2] = Z.val;
						pos = SuperController.singleton.rightHand.transform.TransformPoint(pos);
						rot2 = SuperController.singleton.rightHand.transform.rotation;
					}

					if (rev_Bool.val) {
						rev = Quaternion.Euler(0f, 180f, 0f);
					} else {
						rev = Quaternion.Euler(0f, 0f, 0f);						
					}

                    if (linkBool.val == false) {
    					if (x_Abs_Bool.val)  {
    					    pos[0] = X.val;
    					}
    					if (y_Abs_Bool.val)  {
    					    pos[1] = Y.val;
    					}
    					if (z_Abs_Bool.val)  {
    					    pos[2] = Z.val;
    					}

                        if (xa_Abs_Bool.val)  {
                            rot2[0] = 0f;
                        }
                        if (ya_Abs_Bool.val)  {
                            rot2[1] = 0f;
                        }
                        if (za_Abs_Bool.val)  {
                            rot2[2] = 0f;
                        }

                    }

					containingAtom.GetStorableByID("control").transform.position = pos;
					rot3 = Quaternion.Euler(Xa.val*90f, Ya.val*90f, Za.val*90f);
					containingAtom.GetStorableByID("control").transform.rotation = rot2 * rot3 * rev;
				}
				else {
					linkBool.val = false;
				}

				if (linkBool.val == false) {
					linkBoolval = false;
					ChangeLink();					
				} else {
					linkBoolval = true;
					ChangeLink();					
				}
								
				if (currentTarget != Target.val) {
					currentTarget = Target.val;
					//SuperController.LogMessage("Target Change");
					ChangeLink();
				}
			}
			catch (Exception e) {
				SuperController.LogError("Exception caught: " + e);
			}
		}

		void ChangeLink() {
			if (linkBoolval) {
				ChangeTarget();
			} else {
				StopLink();
			}
		}

		void ChangeTarget() {
			FreeControllerV3 Control = containingAtom.GetStorableByID("control") as FreeControllerV3;
			Control.currentPositionState = FreeControllerV3.PositionState.ParentLink;
			Control.currentRotationState = FreeControllerV3.RotationState.ParentLink;
			linkToAtom = SuperController.singleton.RigidbodyNameToRigidbody("[CameraRig]:" + Target.val);
			Control.SelectLinkToRigidbody(linkToAtom, FreeControllerV3.SelectLinkState.PositionAndRotation);
		}

		void StopLink() {
			FreeControllerV3 Control = containingAtom.GetStorableByID("control") as FreeControllerV3;
			Control.currentPositionState = FreeControllerV3.PositionState.On;
			Control.currentRotationState = FreeControllerV3.RotationState.On;
			linkToAtom = SuperController.singleton.RigidbodyNameToRigidbody("None:None");
			Control.SelectLinkToRigidbody(linkToAtom, FreeControllerV3.SelectLinkState.PositionAndRotation);
		}

        public void OnDisable() {
            try {
				StopLink();
            } catch (Exception e) {
				
            }
        }
	}
}
